/*******************************************************
*Copytight(C),2022,Shanghai Eastsoft Microelectronics Co.,Ltd.
*文件名：iap_chipID.c
*作  者：AE Team
*版  本：v1.0，编译于iDesigner(v4.2.3.186) + 工具链HRCC(v1.2.0.124)
*日  期：2022/12/01
*描  述：IAP读芯片ID，配置字需使能FREN。
		 ID0：80FCH 
		 ID1：80FDH
		 运行程序，监视变量chipID。
        注意：建议IAP操作前关闭WDT，若使能WDT，请设置合理的WDT溢出时间，并合理清狗。
*备  注：本软件仅供学习和演示使用，对用户直接引用代码所带来的风险或后果不承担任何法律责任。
*******************************************************/
#include <hic.h>

#define CLRWDT()   {__Asm CWDT;}    //宏定义清狗指令

unsigned long ID[2];	            //ID[0]低16位存放ID0，ID[1]低16位存放ID1
unsigned long chipID;               //保存芯片ID

/******************************************************
函数名：void RAMclear(void)
描  述：RAM区数据清零，RAM区地址0x0000~0x03FF
输入值：无
输出值：无
返回值：无
*******************************************************/
void RAMclear(void)
{
    for (IAAH=0; IAAH<=0x03; IAAH++)
    {
        for (IAAL=0; IAAL<0xFF; IAAL++)
            IAD = 0x00;
        IAD = 0x00;
    }
}

/******************************************************
函数名：void GPIOInit(void)
描  述：首先初始化所有未用到的IO口为输出低电平
输入值：无
输出值：无
返回值：无
*******************************************************/
void GPIOInit(void)
{
    ANSL = 0xFF;        //选择对应端口为数字IO功能
	ANSH = 0xFF;        //选择对应端口为数字IO功能
    PAT = 0x00;         //所有IO设为输出低电平
    PBT = 0x00;
    PCT = 0x00;
    PA = 0x00;
    PB = 0x00;
    PC = 0x00;
}

/*******************************************************
函数名：void FlashRdID(unsigned long *ptr)
描  述：读芯片ID
输入值：容量至少为2个Words的数组指针
输出值：无
返回值：无
*******************************************************/
void FlashRdID(unsigned long *ptr)
{
	unsigned char idp;
	unsigned char gie_bk = GIE;		//备份GIE
    CLRWDT();
	while(GIE) GIE = 0;
	DATARDEN = 1;                   //数据区和信息区读出使能
	for (idp = 0; idp < 2; idp++)
	{
		FRAH = (0x80FC + idp) >> 8;
		FRAL = (0x80FC + idp);
		DATARDTRG = 1;              //读触发
		while(DATARDTRG) ;          //等待读完成
		__Asm TBR;		            //查表读指令
		ptr[idp] = ((unsigned long)ROMD1H << 24) | ((unsigned long)ROMD1L << 16) | ((unsigned long)ROMDH << 8) | ROMDL;
	}	
    ROMCL = 0x00;                   //退出读操作
	GIE = gie_bk;                   //恢复全局中断
}

/*******************************************************
函数名：void main(void)
描  述：主函数
输入值：无
输出值：无
返回值：无
*******************************************************/
void main(void)
{
    RAMclear();
    GPIOInit();
    CLRWDT();

/******************IAP读出(示例)********************/
    FlashRdID(&ID);	//读chipID
    chipID = (ID[0] << 16) | (ID[1] & 0xFFFF);  //将chipID转换为单个32位数据
    CLRWDT();
    while (1)
    {
        CLRWDT();
    }
}